mergeObjects(multiscroll, {
	activate : { buttonDown : false },

	event : {
		goodToActivate : function(evt) {
			return parseInt(evt.button) == multiscroll.activate.button
				 && evt.shiftKey == multiscroll.activate.shift
				 && evt.ctrlKey == multiscroll.activate.ctrl
				 && evt.altKey == multiscroll.activate.alt
				 && evt.metaKey == multiscroll.activate.meta;
		},
		click : function(evt) {
			var button = parseInt(evt.button);

			if (multiscroll.event.goodToActivate(evt) && !multiscroll.action.Default.active
				 && evt.detail == multiscroll.activate.action)
				multiscroll.action.Default.start(evt);
		},
		mouseDown : function(evt) {
			var button = parseInt(evt.button);
			var action = multiscroll.mouse.button.action(button);
		
			if (button == multiscroll.activate.button)
				multiscroll.activate.buttonDown = true;
			if (multiscroll.activate.action == multiscroll.mouse.action.mousedown
					 && multiscroll.event.goodToActivate(evt)
					 && !multiscroll.action.Default.active) {
				if (!multiscroll.isLink(evt.originalTarget)
						 && !multiscroll.isChrome(evt.target)
						 && !multiscroll.isTabStrip(evt.originalTarget))
					multiscroll.action.Default.start(evt);
			} else if (multiscroll.action.Default.active && action.tool != multiscroll.none) {
				evt.preventDefault();
				action.active = true;
				multiscroll.action.Default.stop(evt);
				action.start(evt);
			} else if (multiscroll.action.Default.done) {
				multiscroll.action.Default.stop(evt);
			}
		},
		mouseUp : function(evt) {
			var button = parseInt(evt.button);
			var action = multiscroll.mouse.button.action(button);

			if (button == multiscroll.activate.button)
				multiscroll.activate.buttonDown = false;
			if (action.active && action.tool != multiscroll.none && action.tool.settings != multiscroll.action.Default.settings )
				action.stop(evt);
			if (!multiscroll.snapOn || multiscroll.exitAction == multiscroll.mouse.action.release)
				multiscroll.action.Default.stop(evt);
		},
		mouseMove : function(evt) {
			if (!multiscroll.isChrome(evt.target) && !multiscroll.isTabStrip(evt.originalTarget)) {
				multiscroll.clientX = evt.clientX;
				multiscroll.clientY = evt.clientY;
				multiscroll.browserClientX = evt.screenX - window.screenX - multiscroll.clientX;
				multiscroll.browserClientY = evt.screenY - window.screenY - multiscroll.clientY;
			} else {
				multiscroll.clientX = evt.screenX - window.screenX - multiscroll.browserClientX;
				multiscroll.clientY = evt.screenY - window.screenY - multiscroll.browserClientY;
			}	// this needs to be here, other code uses clientX and clientY
		
			if (multiscroll.activate.buttonDown
					 && multiscroll.exitAction == multiscroll.mouse.action.drag
					 && !multiscroll.snapOn)
				multiscroll.action.Default.stop(evt);
			
			if (multiscroll.tool.active.Do != undefined)
				multiscroll.tool.active.Do();
		
			if (multiscroll.action.Default.active) {
				var dx = Math.abs(multiscroll.clientX - multiscroll.startX);
				var dy = Math.abs(multiscroll.clientY - multiscroll.startY);
		
				if (dx > multiscroll.dragRadius || dy > multiscroll.dragRadius)
					multiscroll.snapOn = false;
			}
		},
		resize : function(evt) {
			if (multiscroll.pan.thumbnailPreload && !multiscroll.pan.active)
				window.setTimeout(multiscroll.pan.createThumbnailInAdvance, 1, evt);
		},
		load : function(evt) {
			if (multiscroll.pan.thumbnailPreload && !multiscroll.pan.active)
				window.setTimeout(multiscroll.pan.createThumbnailInAdvance, 100, evt);
		},
		keyPress : function(evt) {
			if (evt.keyCode == multiscroll.cancelKey && !multiscroll.none.active) {
				multiscroll.clientFrame.scrollTo(multiscroll.savedX, multiscroll.savedY);
				// MUST be in this order otherwise we get redraw problems
				multiscroll.none.start(evt);
			}
		}
	}
});
